#!/bin/sh

key_type=ECDSA

if [ "${key_type}" == "ECDSA" ];then

  # create private key in pkcs1 format
  #   without passphrase
  # openssl ecparam -name secp256k1 -genkey -noout -out agent.key
  #   with passphrase
  openssl ecparam -genkey -name secp256k1 | openssl ec -aes256 -passout pass:"jobscheduler" -out agent.key

  # create certificate
  openssl req -new -x509 -key agent.key -passin pass:"jobscheduler" -out agent.crt -days 1825

  # extract public key from private key
  openssl ec -in agent.key -passin pass:"jobscheduler" -pubout > agent.pub

else

  # create private key in pkcs1 format
  #  without passphrase
  #  openssl req -x509 -sha256 -newkey rsa:2048 -keyout agent.key -out agent.crt
  #  with passphrase
  openssl req -x509 -sha256 -newkey rsa:2048 -passout pass:"jobscheduler" -keyout agent.key -out agent.crt

  # extract public key from certificate
  openssl x509 -pubkey -noout -in agent.crt > agent.pub

fi

